#!/usr/bin/env python
# -*- coding: utf-8 -*-

import RPi.GPIO as GPIO
import DHT11_Python.dht11
import requests

import time
import datetime
import json

api_host = "192.168.11.150"
api_port = "3000"
url = "http://"+api_host+":"+api_port
interval = 60
data_count = 300/interval

GPIO.setwarnings(False)
GPIO.setmode(GPIO.BCM)
GPIO.cleanup()
sensor = DHT11_Python.dht11.DHT11(pin=14)


def save_data(data):
        # 保存するデータを用意
        savedata = {"data":json.JSONEncoder().encode(data)}
        out = json.JSONEncoder().encode(savedata)

        # POST でデータを書き込む
        resp = requests.post(url+"/block/", data=out, headers={'content-type': 'application/json'})

        return 


data = []
count = 0
while True:
        count = count + 1

        # センサーからデータ取得
	result = sensor.read()
	if result.is_valid():
                temperature = result.temperature
                humidity = result.humidity
                now = datetime.datetime.now().isoformat()

                print "Temperature=" + str(result.temperature), ", Humidity="+str(result.humidity)

                # データを作る
                data.append({"time":now, "temperature":temperature, "humidity":humidity})
        else:
                print "Failed to get Sensor data."


	if count == data_count:
                # データ保存
                save_data(data)
                count = 0
                data = []

        time.sleep(interval)




