var async = require('async');

// Ethereumに接続するためのライブラリ読み込み
var Web3 = require('web3');

// Ethereumに接続(gethコマンドを実行してAPI受付を行っているノードに接続)
var web3 = new Web3('http://10.1.99.117:8545');


// 処理を行うためにアカウントをアンロックしておく
var account = "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";
var password = "YYYYYYYYYY";

// コントラクトのIF情報(solcで生成したABI情報)
var abi = [{"constant":false,"inputs":[{"name":"x","type":"uint256"}],"name":"set","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"get","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"}];
// コントラクトのアドレス
var addr = "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";


// Ethereumのスマートコントラクト呼び出しの準備
var my_data = new web3.eth.Contract(abi, addr);

var cur_val = 0;
async.waterfall([
        // 処理を行うためにアカウントをアンロックしておく
        function(callback) {
                web3.eth.personal.unlockAccount(account, password)
                        .then(function(val) {console.log("unlock");callback(null)});
        },
        // 現在設定されている値を読み込む
        function(callback) {
                my_data.methods.get().call()
                        .then(function(val) {console.log("before:", val);callback(null, val)});
        },
        // 値を更新して保存
        function(val, callback) {
                val = Number(val) + 10;
                console.log("try to set:", val);
                my_data.methods.set(val).send({from:account})
                        .then(function(val) {callback(null, val)});
        },
        // 現在設定されている値を読み込む
        function(val, callback) {
                my_data.methods.get().call().then(function(val) {console.log("after:", val);callback(null, val)});
        },],
        function(err, val) {
                console.log("result = ", val)
        }
);



